﻿Imports System.Data.Entity
Imports GalaSoft.MvvmLight
Imports MahApps.Metro.Controls.Dialogs
Imports System.Windows.Threading
Imports System.Collections.Specialized
Imports System.Threading
Imports System.ComponentModel
Imports System.Configuration
Imports System.Text
Imports System.Collections.ObjectModel
Imports GalaSoft.MvvmLight.CommandWpf
Imports System.Xml


'http://dotnetpattern.com/mvvm-light-messenger => Infos about mvvm light messenger

Namespace MyErp.ViewModel
    ''' <summary>
    ''' This class contains properties that the main View can data bind to.
    ''' <para>
    ''' Use the <strong>mvvminpc</strong> snippet to add bindable properties to this ViewModel.
    ''' </para>
    ''' <para>
    ''' You can also use Blend to data bind with the tool's support.
    ''' </para>
    ''' <para>
    ''' See http://www.galasoft.ch/mvvm
    ''' </para>
    ''' </summary>
    Partial Public Class MainViewModel
        Inherits MyViewModelBase


        'Changeable Zoom Variable is used in the MainWindow for using the Zoom Slider
        Dim vZoom As Double = 1
        Public Overloads Property Zoom As Double
            Get
                If SingletonUserRights.Instance.CurrentUser Is Nothing Then Return 1
                Return SingletonUserRights.Instance.CurrentUser.Zoom
                'Return vZoom
            End Get
            Set(value As Double)
                vZoom = value
                Dim vCUser = SingletonUserRights.Instance.CurrentUser
                vCUser.Zoom = value
                'Save it directly to the database:
                dbo.Users.Where(Function(x) x.Id = vCUser.Id).First.Zoom = value
                dbo.SaveChanges()
                RaisePropertyChanged("Zoom")
                RaisePropertyChanged("CurrentUser")
            End Set
        End Property

        Public ReadOnly Property CurrentUser As User
            Get
                Return SingletonUserRights.Instance.CurrentUser
            End Get
        End Property


        Public ReadOnly Property UsedMemory As Long
            Get
                'Return it in MB
                Debug.Print($"Memory: {GC.GetTotalMemory(True) / 1024 ^ 2}")
                Return CLng(GC.GetTotalMemory(True) / 1024 ^ 2)
            End Get
        End Property

        ''' <summary>
        ''' Saves current user settings to database
        ''' </summary>
        Public Sub SaveCurrentUserSettings()
            Dim vCUser As User = SingletonUserRights.Instance.CurrentUser
            If vCUser Is Nothing Then
                Return
            Else
                vCUser.Zoom = Zoom
                Try
                    dbo.Entry(vCUser).State = EntityState.Modified
                    dbo.SaveChanges()
                Catch ex As Exception
                    cls_logger.v_logger.Error(ex.Message.ToString)
                End Try
            End If
        End Sub

        'Public Sub SetUserSettings()
        '    Dim vCUser As User = SingletonUserRights.Instance.CurrentUser
        '    If vCUser Is Nothing Then
        '        Return
        '    Else
        '        'Set the settings to the Properties of the model:
        '        Zoom = vCUser.Zoom
        '        RaisePropertyChanged("Zoom")
        '    End If
        'End Sub

        'Global Busyindicator Status:
        Dim v_isbusy As Boolean = True
        Public Property GlobalBusy As Boolean
            Get
                Return v_isbusy
            End Get
            Set(value As Boolean)
                If v_isbusy <> value Then
                    v_isbusy = value
                    RaisePropertyChanged("GlobalBusy")
                End If
            End Set
        End Property

        Public Sub New()
            'Initiating the model
            'Try
            dbo.GetValidationErrors()
            'Catch ex As Exception
            '    If ex.HResult = -2147467259 Then
            '        'Database Path is not valid
            '        'Clear the path in the registry and restart
            '        cls_logger.v_logger.Error("Database Path invalid restart Application with empty lastused path")
            '        SetValueFromRegistryKey("db_lastused", "")
            '        Dim v_msg As New StringBuilder("Der angegebene Datenbankpfad ist nicht gültig oder kann nicht erreicht werden.")
            '        v_msg.AppendLine("Wollen Sie das Programm neu starten?")

            '        If MessageBox.Show(v_msg.ToString, "Frage", MessageBoxButton.YesNo, MessageBoxImage.Question) = MessageBoxResult.Yes Then
            '            If isRestart = False Then
            '                Process.Start(Application.ResourceAssembly.Location, "-isrestart")
            '                _Splash.Dispatcher.BeginInvoke(DirectCast(AddressOf CleanUpSplash, Action))
            '                Application.Current.Shutdown()
            '            Else
            '                Environment.Exit(0)
            '            End If
            '        End If
            '        Environment.Exit(0)
            '    ElseIf ex.HResult = -2146232060 Then
            '        'Wrong Password:
            '        MessageBox.Show("Falscher Benutzername oder falsches Passwort", "Loginfehler", MessageBoxButton.OK, MessageBoxImage.Error)
            '        Environment.Exit(0)
            '    Else
            '        Debug.Print(ex.Message)
            '        MessageBox.Show("Programm wird beendet, folgender Fehler ist aufgetreten: " & Environment.NewLine & ex.Message, "Validierungsfehler", MessageBoxButton.OK, MessageBoxImage.Error)
            '        cls_logger.v_logger.Error("GetValidation Error: " & ex.ToString)
            '        Environment.Exit(0)
            '    End If
            'End Try
            GlobalBusy = False
            TrySplashMessage("Startup abgeschlossen")

            CurrentlyMainWindowDisplayedObject = UserRoleCenter
            'Register a Messenger to receive "overview" commands which cause an overview view to be displayed:
            MessengerInstance.Register(Of Object)(Me, "overview", Sub(p) CurrentlyMainWindowDisplayedObject = p)

            RaisePropertyChanged("Zoom")
        End Sub

        Dim vUserRoleCenter As New uclRoleCenter
        Public Property UserRoleCenter As uclRoleCenter
            Get
                Return vUserRoleCenter
            End Get
            Set(value As uclRoleCenter)
                vUserRoleCenter = value
                RaisePropertyChanged("UserRoleCenter")
            End Set
        End Property


        Dim vCurrentlyMainWindowDisplayedObject As New Object
        Public Property CurrentlyMainWindowDisplayedObject As Object
            Get
                Return vCurrentlyMainWindowDisplayedObject
            End Get
            Set(value As Object)
                vCurrentlyMainWindowDisplayedObject = value
                RaisePropertyChanged("CurrentlyMainWindowDisplayedObject")
            End Set
        End Property


#Region "Home Menu"

        Public Property AvailableViews As List(Of UserSettingsGrid) = dbo.UserSettingsGrids.Where(Function(x) x.UserId = SingletonUserRights.Instance.CurrentUser.Id AndAlso x.Deleted = False AndAlso x.InDashboard = True).ToList

        Public Property CmdOpenView As New RelayCommand(Of UserSettingsGrid)(Sub(p) OpenView(p, False), Function(p) p IsNot Nothing)
        Public Property CmdOpenViewNewWindow As New RelayCommand(Of UserSettingsGrid)(Sub(p) OpenView(p, True), Function(p) p IsNot Nothing)

        Private Sub OpenView(vViewToOpen As UserSettingsGrid, vNewWindow As Boolean)
            If vViewToOpen Is Nothing OrElse vViewToOpen.Deleted = True Then Exit Sub

            Select Case True
                Case vViewToOpen.GridName.ToLower = "dgArticles".ToLower
                    Dim vVM As New VMArticleMenu
                    If vNewWindow Then
                        vVM.CmdArticlesOverviewNewWindow.Execute(vViewToOpen)
                    Else
                        vVM.CmdArticlesOverview.Execute(vViewToOpen)
                    End If
                Case Else
                    Return
            End Select
        End Sub
#End Region

    End Class
End Namespace
