﻿''' <summary>
''' This singleton holds all settings for the current session
''' </summary>
Public Class CurrentSessionSettingsCls
    Private Shared ReadOnly vInstance As New Lazy(Of CurrentSessionSettingsCls)(Function() New CurrentSessionSettingsCls(), Threading.LazyThreadSafetyMode.ExecutionAndPublication)

    Public Shared ReadOnly Property Instance As CurrentSessionSettingsCls
        Get
            Return vInstance.Value
        End Get
    End Property


    ''' <summary>
    ''' Holds the current connectionstring for this session
    ''' </summary>
    ''' <returns></returns>
    Public Property ConnectionString As String

    ''' <summary>
    ''' Function creates a connectionstring with the given parameters
    ''' Note: all parameters are mandatory
    ''' Created ConnectionString is stored in the singleton CurrentSessionsSettingsCls Class in Property ConnectionString
    ''' </summary>
    ''' <param name="vServer">Name of the database server</param>
    ''' <param name="vDatabase">Name of the database on the server</param>
    ''' <param name="vUsername">SQL Username to connect</param>
    ''' <param name="vPwd">Password of the user</param>
    ''' <returns>True => Connectionstring was successfully build False => something went wrong</returns>
    Public Function ConnectionStringBuilder(vServer As String, vDatabase As String, vUsername As String, vPwd As String) As Boolean
        If vServer = "" OrElse vDatabase = "" OrElse vUsername = "" OrElse vPwd = "" Then Return False

        'Build a connectionstring:

    End Function

End Class
