Imports System.Collections.ObjectModel
Imports Model.Interfaces

Namespace MyERP2Model
    Partial Public Class Article
        Inherits ModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp
        Implements IProtocolable


        'Dim vCostPriceFix As Decimal = 0D 'new
        'Dim vCostPricePlanned As Decimal = 0D 'new
        'Dim vOverheadCostRate As Decimal = 0 'new
        'Dim vIndirectCostPerc As Decimal = 0 'new
        'Dim vDirectCost As Decimal = 0 'new
        'Dim vContributionMargin As Decimal = 0 'new
        '
        'Dim vNoStockValuation As Boolean = False 'new
        ' 'new
        'Dim vSparePart As Boolean = False 'new
        'Dim vWarePart As Boolean = False 'new
        'Dim vMinStockCheck As Boolean = False 'new
        'Dim vMinStock As Decimal 'new
        'Dim vPrecision As Integer = 1 'new

        'taken from NAV
        'allgemein

        'Artikelkategoriencode =>nv
        'Produktgruppencode =>nv
        'Produktkategorie Fertigung =>nv
        'Produkttypencode Fertigung =>nv
        'lagerabgangsmethode =>nv

        'Preisauswahl =>nv
        'Produkbuchungsgruppe =>nv
        'Lagerbuchungsgruppe =>nv
        'Produktkategorie Vertrieb =>nv
        'Produkttypencode Vertrieb =>nv
        'Kreditorennummer =>nv
        'Produktkategorie einkauf =>nv
        'Produkttypencode einkauf =>nv
        'Arbeitsplannummer =>NV
        'Stcklistennummer =>NV
        'Buchungsmethode =>nv
        'wiederbeschaffung => nv
        'Reservieren => nv
        'Bedarfsverursacherart => nv
        'Toleranzperiode => nv
        'Toleranzmenge
        'Sicherheitsbeschaffungszuschlag
        'Sicherheitsbestand



#Region "Mapped"

#Region "Base"
        Public Property Id As Guid
        Public Property ArtNr As String
#End Region

#Region "Status"
        Public Property ArticleType As Integer
        Public Property BasicUnitId As Guid
        Public Property IsLocked As Boolean
#End Region

#Region "Description"
        Public Property Description1 As String
        Public Property Description2 As String
        Public Property Description3 As String
        Public Property Matchcode As String

#End Region

#Region "Purchase"
        Public Property ProcurementStatus As Integer
        Public Property ProcurementTime As Integer
        Public Property SupplierArtNr As String
        Public Property PurchaseLocked As Boolean
        Public Property PurchaseManagement As Integer
        Public Property CriticalArticle As Boolean
#End Region

#Region "Production"
        Public Property ProductionLocked As Boolean
        Public Property ProductionType As Integer
        Public Property ProductionWastePerc As Decimal
        Public Property LotSize As Decimal
#End Region

#Region "Sales"
        Public Property SalesStatus As Integer
        Public Property AllowDiscount As Boolean
        Public Property DiscountGroupId As Guid?
        Public Property VATGroupId As Guid?
        Public Property SalesUnitId As Guid?
#End Region

#Region "Calculation"
        Public Property CostFix As Decimal
        Public Property CostVariable As Decimal
        Public Property SalesPriceCalculation As Integer
#End Region

#Region "Dimensions"
        Public Property DimWeight As Decimal?
        Public Property DimWeightUnitId As Guid?
        Public Property DimArea As Decimal?
        Public Property DimAreaUnitId As Guid?
        Public Property DimVolume As Decimal?
        Public Property DimVolumeUnitId As Guid?
        Public Property DimLength As Decimal?
        Public Property DimWidth As Decimal?
        Public Property DimHeight As Decimal?
        Public Property DimDimUnitId As Guid?
#End Region

#Region "Stock"
        Public Property MinStock As Integer
        Public Property MaxStock As Integer
        Public Property MinStockWarning As Boolean
        Public Property MaxStockWarning As Boolean
        Public Property NoNegativeStock As Boolean
#End Region

#Region "Export"
        Public Property TaricNo As String
        Public Property OriginCountryCode As String
#End Region

#End Region

#Region "Navigation Properties"
        Public Overridable Property NvArticleSalesPrices As New ObservableCollection(Of ArticleSalesPrice)
        Public Overridable Property NvDescription As New ObservableCollection(Of ObjectDescription)
        Public Overridable Property NvNotes As New ObservableCollection(Of ObjectNote)
        Public Overridable Property NVArticleDescriptions As New ObservableCollection(Of TextDescriptionHeader)
        Public Overridable Property NvUnitWeight As Unit
        Public Overridable Property NvUnitDimension As Unit
        Public Overridable Property NvUnitArea As Unit
        Public Overridable Property NvUnitVolume As Unit
        Public Overridable Property NvUnitBase As Unit
        Public Overridable Property NvUnitSales As Unit
        Public Overridable Property NVVATGroup As VatGroup
        Public Overridable Property NVDiscountGroup As DiscountGroup
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
        Public Property Protocol As ICollection(Of Protocol) Implements IProtocolable.Protocol
#End Region


    End Class
End Namespace