Imports System.Collections.ObjectModel
Imports Model.Interfaces

Namespace MyERP2Model
    Partial Public Class Unit
        Inherits ModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp

#Region "Mapped"
        Public Property Id As Guid
        Public Property ShortName As String
        Public Property LongName As String
        Public Property SIConversion As Decimal
        Public Property UnitType As Integer
#End Region

#Region "Navigation Properties"
        Public Overridable Property NvWeightUnitArticle As New ObservableCollection(Of Article)
        Public Overridable Property NvDimensionUnitArticle As New ObservableCollection(Of Article)
        Public Overridable Property NvAreaUnitArticle As New ObservableCollection(Of Article)
        Public Overridable Property NvVolumeUnitArticle As New ObservableCollection(Of Article)
        Public Overridable Property NvBaseUnitArticle As New ObservableCollection(Of Article)
        Public Overridable Property NvSalesUnitArticle As New ObservableCollection(Of Article)
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
#End Region

    End Class
End Namespace