﻿Imports System.Collections.ObjectModel
Imports Model.Interfaces

Namespace MyERP2Model
    Public Class User
        Inherits ModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp

#Region "Mapped"
        Public Property Id As Guid
        Public Property Username As String
        Public Property Firstname As String
        Public Property Lastname As String
        Public Property Title As String
        Public Property Email As String
        Public Property Phone As String
        Public Property Zoom As Double
#End Region

#Region "Navigation Properties"
        Public Overridable Property NvUserUserGroup As New ObservableCollection(Of UserUserGroup)
        Public Overridable Property NvUsersSettingsGrid As New ObservableCollection(Of UserSettingsGrid)
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
#End Region
    End Class
End Namespace