Imports System.Collections.ObjectModel
Imports Model.Interfaces
Imports Model.MyERP2Model
Imports ViewModel.Interfaces

Namespace ViewModel
    Partial Public Class ClientVM
        Inherits MyViewModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp
        Implements IProtocolableVM

        Dim _BaseItem As Client

        Public Sub New()
        End Sub
        Friend Sub New(__BaseItem As Client)
            _BaseItem = __BaseItem
        End Sub

#Region "Mapped"
        Public Property Id As Guid
            Get
                Return _BaseItem.Id
            End Get
            Set(value As Guid)
                _BaseItem.Id = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property StatusId As Integer
            Get
                Return _BaseItem.StatusId
            End Get
            Set(value As Integer)
                _BaseItem.StatusId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IdentNr As String
            Get
                Return _BaseItem.IdentNr
            End Get
            Set(value As String)
                _BaseItem.IdentNr = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property OwningUserId As Integer
            Get
                Return _BaseItem.OwningUserId
            End Get
            Set(value As Integer)
                _BaseItem.OwningUserId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IsActive As Boolean?
            Get
                Return _BaseItem.IsActive
            End Get
            Set(value As Boolean?)
                _BaseItem.IsActive = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IsPrivate As Boolean?
            Get
                Return _BaseItem.IsPrivate
            End Get
            Set(value As Boolean?)
                _BaseItem.IsPrivate = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IsLead As Boolean?
            Get
                Return _BaseItem.IsLead
            End Get
            Set(value As Boolean?)
                _BaseItem.IsLead = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Navigation Properties"
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
            Get
                Return _BaseItem.DeletedFlag
            End Get
            Set(value As Boolean)
                _BaseItem.DeletedFlag = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
            Get
                Return _BaseItem.DeletedTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.DeletedTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
            Get
                Return _BaseItem.LastUpdateTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.LastUpdateTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
            Get
                Return _BaseItem.CreationTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.CreationTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Protocol As ICollection(Of ProtocolVM) Implements IProtocolableVM.Protocol
#End Region
    End Class
End Namespace