Imports System.Collections.ObjectModel
Imports Model.Interfaces
Imports Model.MyERP2Model
Imports ViewModel.Interfaces

Namespace ViewModel
    Partial Public Class ContactBaseVM
        Inherits MyViewModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp
        Implements IProtocolableVM

        Dim _BaseItem As ContactBase

        Public Sub New()
        End Sub
        Friend Sub New(__BaseItem As ContactBase)
            _BaseItem = __BaseItem
        End Sub

#Region "Mapped"
        Public Property Id As Guid
            Get
                Return _BaseItem.Id
            End Get
            Set(value As Guid)
                _BaseItem.Id = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property SupplierId As Guid?
            Get
                Return _BaseItem.SupplierId
            End Get
            Set(value As Guid?)
                _BaseItem.SupplierId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property ClientId As Guid?
            Get
                Return _BaseItem.ClientId
            End Get
            Set(value As Guid?)
                _BaseItem.ClientId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Name1 As String
            Get
                Return _BaseItem.Name1
            End Get
            Set(value As String)
                _BaseItem.Name1 = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Name2 As String
            Get
                Return _BaseItem.Name2
            End Get
            Set(value As String)
                _BaseItem.Name2 = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Name3 As String
            Get
                Return _BaseItem.Name3
            End Get
            Set(value As String)
                _BaseItem.Name3 = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Email As String
            Get
                Return _BaseItem.Email
            End Get
            Set(value As String)
                _BaseItem.Email = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Web As String
            Get
                Return _BaseItem.Web
            End Get
            Set(value As String)
                _BaseItem.Web = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Phone As String
            Get
                Return _BaseItem.Phone
            End Get
            Set(value As String)
                _BaseItem.Phone = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Fax As String
            Get
                Return _BaseItem.Fax
            End Get
            Set(value As String)
                _BaseItem.Fax = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property VatNo As String
            Get
                Return _BaseItem.VatNo
            End Get
            Set(value As String)
                _BaseItem.VatNo = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property VatnoLastCheck As Date?
            Get
                Return _BaseItem.VatnoLastCheck
            End Get
            Set(value As Date?)
                _BaseItem.VatnoLastCheck = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Jurisdiction As String
            Get
                Return _BaseItem.Jurisdiction
            End Get
            Set(value As String)
                _BaseItem.Jurisdiction = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property FbNo As String
            Get
                Return _BaseItem.FbNo
            End Get
            Set(value As String)
                _BaseItem.FbNo = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DvrNo As String
            Get
                Return _BaseItem.DvrNo
            End Get
            Set(value As String)
                _BaseItem.DvrNo = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Typ As Integer?
            Get
                Return _BaseItem.Typ
            End Get
            Set(value As Integer?)
                _BaseItem.Typ = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property EmployerCount As Integer?
            Get
                Return _BaseItem.EmployerCount
            End Get
            Set(value As Integer?)
                _BaseItem.EmployerCount = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LegalformId As Guid?
            Get
                Return _BaseItem.LegalformId
            End Get
            Set(value As Guid?)
                _BaseItem.LegalformId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Capital As Decimal?
            Get
                Return _BaseItem.Capital
            End Get
            Set(value As Decimal?)
                _BaseItem.Capital = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LanguageId As Guid?
            Get
                Return _BaseItem.LanguageId
            End Get
            Set(value As Guid?)
                _BaseItem.LanguageId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property OwningUserId As Guid?
            Get
                Return _BaseItem.OwningUserId
            End Get
            Set(value As Guid?)
                _BaseItem.OwningUserId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IncotermsId As Guid?
            Get
                Return _BaseItem.IncotermsId
            End Get
            Set(value As Guid?)
                _BaseItem.IncotermsId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property IncotermsComment As String
            Get
                Return _BaseItem.IncotermsComment
            End Get
            Set(value As String)
                _BaseItem.IncotermsComment = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CurrencyId As Guid?
            Get
                Return _BaseItem.CurrencyId
            End Get
            Set(value As Guid?)
                _BaseItem.CurrencyId = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Logo As Byte()
            Get
                Return _BaseItem.Logo
            End Get
            Set(value As Byte())
                _BaseItem.Logo = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property PosDiscountAllowed As Boolean
            Get
                Return _BaseItem.PosDiscountAllowed
            End Get
            Set(value As Boolean)
                _BaseItem.PosDiscountAllowed = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property PricesInclVAT As Boolean
            Get
                Return _BaseItem.PricesInclVAT
            End Get
            Set(value As Boolean)
                _BaseItem.PricesInclVAT = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property AdvPaymentPerc As Decimal
            Get
                Return _BaseItem.AdvPaymentPerc
            End Get
            Set(value As Decimal)
                _BaseItem.AdvPaymentPerc = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Navigation Properties"
        Public Overridable Property NvAdresses As New ObservableCollection(Of AdressVM)
        Public Overridable Property NvCurrencies As CurrencyVM
        Public Overridable Property NvIncoterms As IncotermVM
        Public Overridable Property NvLanguage As LanguageVM
        Public Overridable Property NvLegalForms As LegalFormVM
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
            Get
                Return _BaseItem.DeletedFlag
            End Get
            Set(value As Boolean)
                _BaseItem.DeletedFlag = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
            Get
                Return _BaseItem.DeletedTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.DeletedTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
            Get
                Return _BaseItem.LastUpdateTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.LastUpdateTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
            Get
                Return _BaseItem.CreationTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.CreationTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property Protocol As ICollection(Of ProtocolVM) Implements IProtocolableVM.Protocol
#End Region
    End Class
End Namespace