﻿Imports System.Collections.ObjectModel
Imports Model.Interfaces
Imports Model.MyERP2Model

Namespace ViewModel
    Public Class ProtocolVM
        Inherits MyViewModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp

        Dim _BaseItem As Protocol

        Public Sub New()
        End Sub
        Friend Sub New(__BaseItem As Protocol)
            _BaseItem = __BaseItem
        End Sub


        Sub New(_OldValue As String, _NewValue As String, __BaseItem As Protocol)
            OldValue = _OldValue
            NewValue = _NewValue
            _BaseItem = __BaseItem
        End Sub

        Public Overrides Function ToString() As String
            Return $"Oldvale:{OldValue} - NewValue: {NewValue}"
        End Function

#Region "Properties"
        Public Overridable Property Id As Guid
            Get
                Return _BaseItem.Id
            End Get
            Set(value As Guid)
                _BaseItem.Id = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Overridable Property OldValue As String
            Get
                Return _BaseItem.OldValue
            End Get
            Set(value As String)
                _BaseItem.OldValue = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Overridable Property NewValue As String
            Get
                Return _BaseItem.NewValue
            End Get
            Set(value As String)
                _BaseItem.NewValue = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
            Get
                Return _BaseItem.DeletedFlag
            End Get
            Set(value As Boolean)
                _BaseItem.DeletedFlag = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
            Get
                Return _BaseItem.DeletedTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.DeletedTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
            Get
                Return _BaseItem.LastUpdateTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.LastUpdateTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
            Get
                Return _BaseItem.CreationTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.CreationTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

    End Class
End Namespace