﻿Imports System.Collections.ObjectModel
Imports Model.Interfaces
Imports Model.MyERP2Model

Namespace ViewModel
    Public Class UserGroupVM
        Inherits MyViewModelBase
        Implements ILogicalDelete
        Implements ILogicalTimestamp
        Dim _BaseItem As UserGroup

        Public Sub New()
        End Sub
        Friend Sub New(__BaseItem As UserGroup)
            _BaseItem = __BaseItem

            For Each item As UserUserGroup In __BaseItem.NvUserUsergroup
                NvUserUsergroup.Add(New UserUserGroupVM(item))
            Next

            For Each item As UserGroupRight In __BaseItem.NvUserGroupRights
                NvUserGroupRights.Add(New UserGroupRightVM(item))
            Next

        End Sub

#Region "Mapped"
        Public Property Id As Guid
            Get
                Return _BaseItem.Id
            End Get
            Set(value As Guid)
                _BaseItem.Id = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property InternalGroupName As String
            Get
                Return _BaseItem.InternalGroupName
            End Get
            Set(value As String)
                _BaseItem.InternalGroupName = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property GroupName As String
            Get
                Return _BaseItem.GroupName
            End Get
            Set(value As String)
                _BaseItem.GroupName = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region


#Region "Navigation Properties"
        Public Overridable Property NvUserUsergroup As New ObservableCollection(Of UserUserGroupVM)
        Public Overridable Property NvUserGroupRights As New ObservableCollection(Of UserGroupRightVM)
#End Region

#Region "Interfaces"
        Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag
            Get
                Return _BaseItem.DeletedFlag
            End Get
            Set(value As Boolean)
                _BaseItem.DeletedFlag = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp
            Get
                Return _BaseItem.DeletedTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.DeletedTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp
            Get
                Return _BaseItem.LastUpdateTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.LastUpdateTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
        Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp
            Get
                Return _BaseItem.CreationTimestamp
            End Get
            Set(value As Date?)
                _BaseItem.CreationTimestamp = value
                RaisePropertyChanged()
            End Set
        End Property
#End Region

    End Class
End Namespace